from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  hashall = 3
  pipefail = 4
  noexec = 5
  xtrace = 6
  verbose = 7
  noglob = 8
  noclobber = 9
  posix = 10
  vi = 11
  emacs = 12
  interactive = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  nullglob = 19
  inherit_errexit = 20
  strict_argv = 21
  strict_arith = 22
  strict_array = 23
  strict_control_flow = 24
  strict_echo = 25
  strict_errexit = 26
  strict_eval_builtin = 27
  strict_nameref = 28
  strict_word_eval = 29
  strict_backslash = 30
  strict_glob = 31
  simple_word_eval = 32
  dashglob = 33
  more_errexit = 34
  simple_test_builtin = 35
  parse_at = 36
  parse_brace = 37
  parse_index_expr = 38
  parse_paren = 39
  parse_rawc = 40
  parse_ignored = 41
  parse_set = 42
  parse_equals = 43
  parse_tea = 44
  expand_aliases = 45
  lastpipe = 46
  progcomp = 47
  histappend = 48
  hostcomplete = 49
  cmdhist = 50
  assoc_expand_once = 51
  autocd = 52
  cdable_vars = 53
  cdspell = 54
  checkhash = 55
  checkjobs = 56
  checkwinsize = 57
  complete_fullquote = 58
  direxpand = 59
  dirspell = 60
  dotglob = 61
  execfail = 62
  extdebug = 63
  extquote = 64
  force_fignore = 65
  globasciiranges = 66
  globstar = 67
  gnu_errfmt = 68
  histreedit = 69
  histverify = 70
  huponexit = 71
  interactive_comments = 72
  lithist = 73
  localvar_inherit = 74
  localvar_unset = 75
  login_shell = 76
  mailwarn = 77
  no_empty_cmd_completion = 78
  nocaseglob = 79
  nocasematch = 80
  progcomp_alias = 81
  promptvars = 82
  restricted_shell = 83
  shift_verbose = 84
  sourcepath = 85
  xpg_echo = 86
  ARRAY_SIZE = 87

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.hashall',
  4: 'option.pipefail',
  5: 'option.noexec',
  6: 'option.xtrace',
  7: 'option.verbose',
  8: 'option.noglob',
  9: 'option.noclobber',
  10: 'option.posix',
  11: 'option.vi',
  12: 'option.emacs',
  13: 'option.interactive',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.nullglob',
  20: 'option.inherit_errexit',
  21: 'option.strict_argv',
  22: 'option.strict_arith',
  23: 'option.strict_array',
  24: 'option.strict_control_flow',
  25: 'option.strict_echo',
  26: 'option.strict_errexit',
  27: 'option.strict_eval_builtin',
  28: 'option.strict_nameref',
  29: 'option.strict_word_eval',
  30: 'option.strict_backslash',
  31: 'option.strict_glob',
  32: 'option.simple_word_eval',
  33: 'option.dashglob',
  34: 'option.more_errexit',
  35: 'option.simple_test_builtin',
  36: 'option.parse_at',
  37: 'option.parse_brace',
  38: 'option.parse_index_expr',
  39: 'option.parse_paren',
  40: 'option.parse_rawc',
  41: 'option.parse_ignored',
  42: 'option.parse_set',
  43: 'option.parse_equals',
  44: 'option.parse_tea',
  45: 'option.expand_aliases',
  46: 'option.lastpipe',
  47: 'option.progcomp',
  48: 'option.histappend',
  49: 'option.hostcomplete',
  50: 'option.cmdhist',
  51: 'option.assoc_expand_once',
  52: 'option.autocd',
  53: 'option.cdable_vars',
  54: 'option.cdspell',
  55: 'option.checkhash',
  56: 'option.checkjobs',
  57: 'option.checkwinsize',
  58: 'option.complete_fullquote',
  59: 'option.direxpand',
  60: 'option.dirspell',
  61: 'option.dotglob',
  62: 'option.execfail',
  63: 'option.extdebug',
  64: 'option.extquote',
  65: 'option.force_fignore',
  66: 'option.globasciiranges',
  67: 'option.globstar',
  68: 'option.gnu_errfmt',
  69: 'option.histreedit',
  70: 'option.histverify',
  71: 'option.huponexit',
  72: 'option.interactive_comments',
  73: 'option.lithist',
  74: 'option.localvar_inherit',
  75: 'option.localvar_unset',
  76: 'option.login_shell',
  77: 'option.mailwarn',
  78: 'option.no_empty_cmd_completion',
  79: 'option.nocaseglob',
  80: 'option.nocasematch',
  81: 'option.progcomp_alias',
  82: 'option.promptvars',
  83: 'option.restricted_shell',
  84: 'option.shift_verbose',
  85: 'option.sourcepath',
  86: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  cd = 23
  pushd = 24
  popd = 25
  dirs = 26
  pwd = 27
  source = 28
  umask = 29
  wait = 30
  jobs = 31
  fg = 32
  bg = 33
  shopt = 34
  complete = 35
  compgen = 36
  compopt = 37
  compadjust = 38
  getopts = 39
  command = 40
  type = 41
  hash = 42
  help = 43
  history = 44
  alias = 45
  unalias = 46
  bind = 47
  push = 48
  append = 49
  write = 50
  getline = 51
  json = 52
  repr = 53
  use = 54
  opts = 55
  cat = 56
  ARRAY_SIZE = 57

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.cd',
  24: 'builtin.pushd',
  25: 'builtin.popd',
  26: 'builtin.dirs',
  27: 'builtin.pwd',
  28: 'builtin.source',
  29: 'builtin.umask',
  30: 'builtin.wait',
  31: 'builtin.jobs',
  32: 'builtin.fg',
  33: 'builtin.bg',
  34: 'builtin.shopt',
  35: 'builtin.complete',
  36: 'builtin.compgen',
  37: 'builtin.compopt',
  38: 'builtin.compadjust',
  39: 'builtin.getopts',
  40: 'builtin.command',
  41: 'builtin.type',
  42: 'builtin.hash',
  43: 'builtin.help',
  44: 'builtin.history',
  45: 'builtin.alias',
  46: 'builtin.unalias',
  47: 'builtin.bind',
  48: 'builtin.push',
  49: 'builtin.append',
  50: 'builtin.write',
  51: 'builtin.getline',
  52: 'builtin.json',
  53: 'builtin.repr',
  54: 'builtin.use',
  55: 'builtin.opts',
  56: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

